# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nik Kim <fafhrd@datacom.kz> 

from Products.Formulator import Form, Field


def BasicForm_get_field(self, id):
    """ """
    try:
        return self.fields[id].__of__(self)
    except:
        return self.fields[id]

Form.BasicForm.get_field = BasicForm_get_field


# i need 'here' in TALES like in ZPT
def new_get_value(self, id):
    """Get value for id."""
    # FIXME: backwards compat hack to make sure tales dict exists
    if not hasattr(self, 'tales'):
        self.tales = {}
        
    tales_expr = self.tales.get(id, "")
    if tales_expr:
        value = tales_expr.__of__(self)(field=self, form=self.aq_parent,
                                        here=self.aq_parent.aq_parent,
                                        request=self.REQUEST)
    else:
        # FIXME: backwards compat hack to make sure overrides dict exists
        if not hasattr(self, 'overrides'):
            self.overrides = {}
                
        override = self.overrides.get(id, "")
        if override:
            # call wrapped method to get answer
            value = override.__of__(self)()
        else:
            # get normal value
            value = self.get_orig_value(id)

    # if normal value is a callable itself, wrap it
    if callable(value):
        return value()
    else:
        return value

Field.Field.get_value = new_get_value


def render_from_request(self, REQUEST, extra=''):
    """ """
    if extra:
        values = self.values
        o_ex = values['extra']
        values['extra'] = o_ex + extra
	res = self._render_helper('field_%s' % self.id, None, REQUEST)
        values['extra'] = o_ex
        return res
    else:
        return self._render_helper('field_%s' % self.id, None, REQUEST)

Field.Field.render_from_request = render_from_request
														    