from Products.CMFCore.TypesTool import FactoryTypeInformation
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName
from Products.CMFFormulator import formulator_globals, factory_type_information

from Acquisition import aq_base
from cStringIO import StringIO
import string

def install(self):
    " Register CMFFormulator types and skins "
    out = StringIO()
    skinsTool = getToolByName(self, 'portal_skins')

    try:
        addDirectoryViews( skinstool, 'skins', formulator_globals )
        out.write( "Added CMFFormulator directory views to portal_skins\n" )
    except:
        pass

    if 'formulator' not in skinsTool.objectIds():
        addDirectoryViews(skinsTool, 'skins', formulator_globals)
        
        out.write("Added 'formulator' directory views to portal_skins\n")

    skins = skinsTool.getSkinSelections()
    for skin in skins:
        path = skinsTool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        if 1 or 'formulator' not in path and skin.startswith('Plone'):
            path.append('formulator')

            path = string.join(path, ', ')
            skinsTool.addSkinSelection(skin, path)
            out.write("Added 'formulator' to %s skins\n" % skin)
        else:
            out.write('Skipping %s skin\n' % skin)

    # install CMFFormulator Types
    typestool = getToolByName(self, 'portal_types')

    for fti in factory_type_information:
        if fti['id'] in typestool.objectIds():
            print >> out, "Overriding Content Type %s"%fti['id']
            typestool._delObject(fti['id'])
        else:
            print >> out, "Register Content Type %s"%fti['id']

        efm = FactoryTypeInformation(**fti)
        typestool._setObject(fti['id'], efm)
        
    out.write( "Added CMFFormulator Types\n" )
    
    return out.getvalue()
